from odoo.upgrade import util
from odoo.osv import expression


def migrate(cr, version):
    # https://github.com/odoo/odoo/pull/116830:
    # - on sale.report the field `order_id` has been removed and *somehow*
    #   replaced by the new `order_reference` field. To avoid loosing user
    #   filters and dashboard actions, we can consider it as a "rename",
    #   except for domain - where we had to remove it.

    def _remove_field_adpater(leaf, is_or, negated):
        # replace by TRUE_LEAF, unless negated or in a OR operation but not negated
        if is_or ^ negated:
            return [expression.FALSE_LEAF]
        return [expression.TRUE_LEAF]

    util.update_field_usage(
        cr, "sale.report", "order_id", "order_reference",
        domain_adapter=_remove_field_adpater
    )
